"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = y[op[0] & 2 ? "return" : op[0] ? "throw" : "next"]) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [0, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var fs = require("fs");
var chai_1 = require("chai");
var config = require(process.cwd() + "/webpack.config.js");
var common_1 = require("@tandem/common");
var test_1 = require("@tandem/editor/test");
var sandbox_1 = require("@tandem/sandbox");
var synthetic_browser_1 = require("@tandem/synthetic-browser");
// TODO - move most of this in util functions - possibly in @tandem/editor/test/utils
// TODO - re-use VM instead of creating a new one each time - should be much faster
describe(__filename + "#", function () {
    var aliases = Object.assign({}, config.resolve.alias, {
        "react": process.cwd() + "/node_modules/react/dist/react.min.js",
        "react-dom": process.cwd() + "/node_modules/react-dom/dist/react-dom.min.js"
    });
    var aliasMockFiles = {};
    for (var name_1 in aliases) {
        var uri = aliases[name_1];
        if (fs.existsSync(uri)) {
            aliasMockFiles[name_1] = fs.readFileSync(uri, "utf8");
        }
    }
    var app;
    before(function () { return __awaiter(_this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    app = test_1.createTestMasterApplication({
                        log: {
                            level: common_1.LogLevel.NONE
                        },
                        sandboxOptions: {
                            mockFiles: aliasMockFiles
                        }
                    });
                    return [4 /*yield*/, app.initialize()];
                case 1:
                    _a.sent();
                    return [2 /*return*/];
            }
        });
    }); });
    var loadJSX = function (jsx) { return __awaiter(_this, void 0, void 0, function () {
        var _this = this;
        var kernel, entryFilePath, browser, getElement;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    kernel = app.kernel;
                    entryFilePath = test_1.createRandomFileName("tsx");
                    return [4 /*yield*/, sandbox_1.URIProtocolProvider.lookup(entryFilePath, kernel).write(entryFilePath, "\n      import React =  require(\"react\");\n      import ReactDOM = require(\"react-dom\");\n      const element = document.createElement(\"div\");\n      ReactDOM.render(" + jsx + ", element);\n      exports.documentElement = element;\n    ")];
                case 1:
                    _a.sent();
                    browser = new synthetic_browser_1.SyntheticBrowser(kernel);
                    return [4 /*yield*/, browser.open({
                            uri: entryFilePath,
                            dependencyGraphStrategyOptions: {
                                name: "webpack"
                            }
                        })];
                case 2:
                    _a.sent();
                    getElement = function () {
                        return browser.document.documentElement.firstChild;
                    };
                    return [2 /*return*/, {
                            entryFilePath: entryFilePath,
                            element: getElement(),
                            editor: sandbox_1.FileEditorProvider.getInstance(kernel),
                            fileCache: sandbox_1.FileCacheProvider.getInstance(kernel),
                            reloadElement: function () { return __awaiter(_this, void 0, void 0, function () {
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0: return [4 /*yield*/, common_1.waitForPropertyChange(browser.sandbox, "exports")];
                                        case 1:
                                            _a.sent();
                                            return [2 /*return*/, getElement()];
                                    }
                                });
                            }); }
                        }];
            }
        });
    }); };
    // testing to ensure the setup code above works
    xit("can render an element", function () { return __awaiter(_this, void 0, void 0, function () {
        var element;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, loadJSX("<div>a</div>")];
                case 1:
                    element = (_a.sent()).element;
                    chai_1.expect(element.textContent).to.equal("a");
                    chai_1.expect(element.$source).not.to.be.undefined;
                    chai_1.expect(element.$source.start).not.to.be.undefined;
                    return [2 /*return*/];
            }
        });
    }); });
    [
        // attribute editsw
        ["<div id=\"a\">Hello</div>", "<div id=\"b\">Hello</div>"],
        ["<div>Hello</div>", "<div id=\"b\">Hello</div>"],
        ["<div>Hello</div>", "<div id=\"b\">Hello</div>"],
        ["<div id=\"a\">Hello</div>", "<div>Hello</div>"],
        ["<div id=\"a\" className=\"b\">Hello</div>", "<div title=\"c\">Hello</div>"],
        ["<div id=\"a\" className=\"b\" />", "<div title=\"c\" />"],
        // container edits
        ["<div></div>", "<div>a</div>"],
        ["<div><span>a</span></div>", "<div>a</div>"],
        ["<div><span>a</span><div>b</div></div>", "<div><div>b</div><span>a</span></div>"],
        ["<div />", "<div>a</div>"],
        ["(\n      <div />\n    )", "<div>aa</div>"],
    ].reverse().forEach(function (_a) {
        var oldSource = _a[0], newSource = _a[1];
        // off for MVP
        xit("can apply typescript file edits from " + oldSource + " to " + newSource, function () { return __awaiter(_this, void 0, void 0, function () {
            var _a, element, editor, fileCache, entryFilePath, reloadElement, newElementResult, edit, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, loadJSX(oldSource)];
                    case 1:
                        _a = _c.sent(), element = _a.element, editor = _a.editor, fileCache = _a.fileCache, entryFilePath = _a.entryFilePath, reloadElement = _a.reloadElement;
                        return [4 /*yield*/, loadJSX(newSource)];
                    case 2:
                        newElementResult = _c.sent();
                        edit = element.createEdit().fromDiff(newElementResult.element);
                        chai_1.expect(edit.mutations.length).not.to.equal(0);
                        editor.applyMutations(edit.mutations);
                        _b = chai_1.expect;
                        return [4 /*yield*/, reloadElement()];
                    case 3:
                        _b.apply(void 0, [(_c.sent()).outerHTML]).to.equal(newElementResult.element.outerHTML);
                        return [2 /*return*/];
                }
            });
        }); });
    });
});
//# sourceMappingURL=ts-editor-test.js.map